import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.tool.DataAnalyseToolApplication;
import com.gct.tool.controller.BaseDataController;
import com.gct.tool.entity.centralbase.CbCdWellSource;
import com.gct.tool.entity.centralbase.CbPcDevWellAttr;
import com.gct.tool.entity.centralbase.CbPcProWellboreStatusDaily;
import com.gct.tool.entity.sql.QueryBody;
import com.gct.tool.entity.vo.BaseDataVo;
import com.gct.tool.mapper.centralbase.CbCdWellSourceMapper;
import com.gct.tool.mapper.centralbase.CbPcProWellboreStatusDailyMapper;
import com.gct.tool.service.LoadBaseDataService;
import org.checkerframework.checker.units.qual.C;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;

import java.io.*;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Objects;

/**
 * @author xusirui 2022/9/28
 */
@SpringBootTest(classes = DataAnalyseToolApplication.class)
@RunWith(SpringRunner.class)
public class MyTest {

    @Autowired
    LoadBaseDataService loadBaseDataService;

    @Autowired
    CbPcProWellboreStatusDailyMapper cbPcProWellboreStatusDailyMapper;

    @Autowired
    CbCdWellSourceMapper cbCdWellSourceMapper;

//    @Autowired
//    CbPcProWellboreVolDailyMapper cbPcProWellboreVolDailyMapper;

    @Test
    public void test() {

            loadBaseDataService.loadWorkDiagramData();

//        cbPcProWellboreVolDailyMapper.selectList(new QueryWrapper<>());
    }

    @Test
    public void test2() {
        List<CbCdWellSource> well = cbCdWellSourceMapper.selectList(new QueryWrapper<>());
        for (int i = 0; i < well.size(); i++) {
            CbCdWellSource wellSource = well.get(i);
            CbPcProWellboreStatusDaily statusDaily = cbPcProWellboreStatusDailyMapper.selectOne(
                    new QueryWrapper<CbPcProWellboreStatusDaily>().eq("well_id", wellSource.getWellId())
                            .eq("prod_date::date", LocalDate.parse("2023-07-09")));
            if (Objects.isNull(statusDaily))continue;
            for (int j=0;j<10;j++){
                statusDaily.setProdDate(statusDaily.getProdDate().minusDays(1));
                cbPcProWellboreStatusDailyMapper.insert(statusDaily);
            }

        }
    }

    @Autowired
    BaseDataController baseDataController;

    @Test
    public void testBase(){
        CbPcDevWellAttr cbPcDevWellAttr = new CbPcDevWellAttr();
        cbPcDevWellAttr.setWellId("WELLTL100019047");
        cbPcDevWellAttr.setCoefficient(0.99);
        baseDataController.updateWellAttr(cbPcDevWellAttr);
    }

    /*
    HA901-3#57#2503.76#900
HA9-12X#44#2823#65
HA9-7C#57#2502.83#7
HA15-2#70/38#1996.45#0
HA9-2#70/38#2496.74#21
HA16-5C#57#2507.1#262
HA901-1C#44#3176.37#162
HA601C#70/38#2203.69#1107
HA12-5#57#2199.72#12
HA601-8C#57#2500.72#0
HA601-46#57#2298.22#0
QIGU1#70/38#2203.04#0
HA11-3#44#3000.1#445
RP1-1#57#2506.98#23
RP1001#57#2501.62#37
RP3-6#44#2505.74#255
RP3014XC#70/38#2203.27#764
RP601C#57#2514.67#1257
XK4001H#70#2005.95#36
XK8-6#70/38#2002.58#854
XK902#57#2204.27#961
XK9004#57#2501.62#38
HA11-8#70/38#2202.24#35
RP11#70#2494.19#0
RP7006#70/38#2002.37#1085
RP7008#57#2185.5#36
RP8-5#70/38#2199.2#502
RP8-6X#70#2001.23#0
XK6001H#70/38#2204.94#
JY1-2C#44#3007.36#1898
JY102#70#2002.11#0
JY104#70#1993.42#0
JY201#44#2499.99#123
DH14#38#3406.2#3256
DH1-H8#38#3596.71#2066
DH1-H17#57#2494.41#882
DH5#44#3198.73#3146
DH4-10#38#3319.64#1060
DH601#44#3203.96#2388.62
DH4-4#44#3808.52#934
DH6-H1#44#3199.49#2612
     */
    @Test
    public void generateSql() throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(getClass().getResourceAsStream("/basedata.txt")));
        String line = "";
        while ((line=br.readLine())!= null){
            String[] split = line.split("#");
            if (split.length<4)continue;
            CbCdWellSource wellSource = cbCdWellSourceMapper.selectOne(new QueryWrapper<CbCdWellSource>().eq("well_legal_name", split[0]));
            if (Objects.isNull(wellSource))continue;
            Double bs = Double.parseDouble(split[2]);
            Double dym = Double.parseDouble(split[3]);
            Double bj = Double.parseDouble(split[1].equals("70/38")?"57":split[1]);
            Double cmd = bs-dym;
            String updateSql = String.format("update centralbase.cb_pc_pro_wellbore_status_daily " +
                    "set pump_depth = %s,start_pump_liq_level=%s,oil_nozzle=%s,submergence_depth=%s where well_id = '%s'"
                    ,bs,dym,bj,cmd,wellSource.getWellId());
            System.out.println(updateSql);
        }
    }

    @Test
    public void generateSql2() throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(getClass().getResourceAsStream("/ymd.txt")));
        String line;
        while ((line=br.readLine())!=null){
            String legalName = line.split("#")[0];
            String ymd = line.split("#")[1];
            CbCdWellSource wellSource = cbCdWellSourceMapper.selectOne(new QueryWrapper<CbCdWellSource>().eq("well_legal_name",legalName));

            String updateSql = String.format("update centralbase.cb_pc_pro_wellbore_vol_daily set surface_crude_oil_density = %s where well_id = '%s'",
                    ymd,wellSource.getWellId());
            System.out.println(updateSql);
        }
    }


}
