package com.gct.tool.entity.centralbase;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

import java.time.LocalDateTime;

/**
 * class name: SysAccessWell
 *
 * @author gxt
 * @version 1.0
 * @since 2021/9/22 上午11:18 周三
 */
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="SysAccessWell对象", description="接入井")
@TableName("centralbase.sys_access_well_control")
@NoArgsConstructor
@AllArgsConstructor
public class SysAccessWellControl {

    @ApiModelProperty(value = "井号")
    private String wellId;

    @ApiModelProperty(value = "井名")
    private String wellCommonName;

    @ApiModelProperty(value = "机构id")
    private String orgId;

    @ApiModelProperty(value = "备注")
    private String remarks;

    @ApiModelProperty(value = "井接入状态；0 未接入, 1 已接入")
    private Integer accessStatus;

    @ApiModelProperty(value = "接入状态描述")
    private String accessStatusMsg;

    @ApiModelProperty(value = "井接入日期")
    private LocalDateTime accessDate;
}
